import pprint
import sys 

def printPig(cls, params,comment=False):
	p = " -param "
	out="pig "+p+p.join(params)+" pig/"+cls+".pig"
	if comment: out="#"+out
	print out
	
def printHadoop(cls,inp, outp, compress, param="",comment=False):
	tmp = " ".join([param,inp,outp, str(compress)])
	out ="hadoop jar lib/thesaurus.distributional.hadoop.jar jobimtext.thesaurus.distributional.hadoop.mapreduce."+cls+tmp
	if comment: out="#"+out 
	print out
def bylength(word1,word2):
    return len(word1)-len(word2)

def removeOutputfolders():
	l = globals()
	folders = []
	for name in l.keys():
		if(name.endswith("_out")):
			folders.append(name+"\t"+ l[name])

	folders.sort(cmp=bylength)
	for f in folders:
		print("#hadoop dfs -rmr "+f)
		#print(f)

if(len(sys.argv)<8):
	print "Parameters needed: dataset s t p significance simsort_count [computer file_prefix]"
	print "dataset: e.g. news10M_ngram_1_3, news10M_maltparser"
	print "wc: maximal number of uniq words a feature is allowed to have" 
	print "s: lower threshold for significance score"
	print "t: lower threshold for word count "
	print "p: maximal number of features a word is allowed to have"
	print "significance: LMI, PMI, LL"
	print "simsort count - number of similar terms sorted in the last step" 
	print "optional parameter:"
	print "computer: computer to copy the files to"
	print "file_prefix: prefix, the files (distributional similarity, WordCount, FeatureCount) will be copied to"
	sys.exit()
	

clsContext ="WordFeatureCount"
clsContextPruning ="PruneFeaturesPerWord"
clsWordCount = "WordCount"
clsFeatureCount = "FeatureCount"
clsFreqSig = "FreqSig"
clsPrunegraph = "PruneGraph"
clsAggregate="AggrPerFt"
clsSimCount="SimCounts1WithFeatures"
clsSimSort="SimSort"




dataset="news1k_parses"
s = 10
t = 10
p = 500

dataset = sys.argv[1]
wc = sys.argv[2]
s  = sys.argv[3]
t  = sys.argv[4]
p  = sys.argv[5]
significance  = sys.argv[6]
simsort_limit = sys.argv[7]



clsFreqSig = clsFreqSig+significance


context_out = dataset+"__"+clsContext
dataset_filter= dataset+"__"+clsContextPruning+"_"+wc;
context_filter_out = dataset_filter+"__"+clsContext
context_filter_p=[]
context_filter_p.append("contextout="+context_out)
context_filter_p.append("out="+context_filter_out)
context_filter_p.append("wc="+wc)

wordcount_out = dataset_filter+"__"+clsWordCount
featurecount_out = dataset_filter+"__"+clsFeatureCount
freqsig_p=[]
freqsig_p.append("s="+str(s))
freqsig_p.append("t="+str(t))
freqsig_out = dataset_filter+"__"+clsFreqSig+"_"+"_".join(freqsig_p).replace("=","_")
freqsig_p.append("wordcountout="+wordcount_out)
freqsig_p.append("featurecountout="+featurecount_out)
freqsig_p.append("contextout="+context_filter_out)
freqsig_p.append("freqsigout="+freqsig_out)
prunegraph_p=[]
prunegraph_p.append("p="+str(p))
prunegraph_out = freqsig_out+"__"+clsPrunegraph+"_"+"_".join(prunegraph_p).replace("=","_")
prunegraph_p.append("freqsigout="+freqsig_out)
prunegraph_p.append("prunegraphout="+prunegraph_out)
aggregate_out=prunegraph_out+"__"+clsAggregate
simcount_p=[]
simcount_out=aggregate_out+"__"+clsSimCount+"_".join(simcount_p).replace("=","_")

simsort_out=simcount_out+"__"+clsSimSort
simsort_p=[]
simsort_p.append("limit="+simsort_limit)
simsort_out=simcount_out+"__"+clsSimSort+"_".join(simsort_p).replace("=","_")
simsort_p.append("IN="+simcount_out)
simsort_p.append("OUT="+simsort_out)
