-- setting the number of parallel mapred tasks
SET default_parallel 100;
SET mapred.job.map.memory.mb 2048
SET mapred.job.reduce.memory.mb 2048

SET mapred.compress.map.output true
SET mapred.output.compression org.apache.hadoop.io.compress.GzipCodec;

%declare TTEST 'news120M__ContextDP_POS_Clean_Lemma__TTEST3';
%declare WORDS 'weeds_words';
%declare OUT 'TTEST_SMALL'; 

W = LOAD '$TTEST' USING PigStorage('\t')  as (wword: chararray, wfeature: chararray, wscore: float);
NOUNS = LOAD '$WORDS' USING PigStorage('\t') as (noun : chararray);

T1 = JOIN NOUNS BY noun, W BY wword;

STORE T1 INTO '$OUT' USING PigStorage('\t');