-- n = sum of all (word,feature) pair counts

-- setting the number of parallel mapred tasks
SET default_parallel 110;
SET mapred.job.map.memory.mb 2048
SET mapred.job.reduce.memory.mb 2048

-- load output of Context class
A = LOAD 'context-out' USING PigStorage('\t')  as (word: chararray, feature: chararray, count: float);

-- t >= 2 ("t" is a command line parameter)
A2 = FILTER A BY count >= $t;

-- group (I don't know why this is necessary)
B = group A2 all;

-- calculate total count of all (word,feature) pairs
Z = foreach B generate SUM(A2.count) as total;

-- the total count (n) is now in Z.total

A = LOAD 'context-out' USING PigStorage('\t')  as (word: chararray, feature: chararray, bothcount: float);
B = LOAD 'wordcount-out' as (word: chararray, wordcount: float);
C = LOAD 'featurecount-out' as (feature: chararray, featurecount: float);
D = JOIN A BY word, B BY word;
E = JOIN D BY feature, C BY feature;

-- E: word feature bothcount word wordcount feature featurecount
-- NEW: add the t, the count of word+feature
F = FOREACH E GENERATE A::word, A::feature, A::bothcount, ( bothcount*LOG( (Z.total*bothcount)/(wordcount*featurecount) ) ) AS s;

-- s > 0
F2 = FILTER F BY s >= $s;

STORE F2 INTO 'freqsigWithT-out' USING PigStorage('\t');