-- setting the number of parallel mapred tasks

SET default_parallel 100;
SET mapred.job.map.memory.mb 2048;
SET mapred.job.reduce.memory.mb 2048;

SET mapred.compress.map.output true;
SET mapred.output.compression org.apache.hadoop.io.compress.GzipCodec;

SIMWORDS = LOAD '$sim' USING PigStorage('\t')  as (word1: chararray, word2:chararray, simscore : float); 
LIN1 = LOAD '$weight_lin' USING PigStorage('\t')  as (w1_word: chararray, w1_feature: chararray, w1_score: float);
LIN2 = LOAD '$weight_lin' USING PigStorage('\t')  as (w2_word: chararray, w2_feature: chararray, w2_score: float);
LINSUM1 = LOAD '$weight_lin_sum' USING PigStorage('\t') as (ls1_word:chararray , ls1_score: float);
LINSUM2 = LOAD '$weight_lin_sum' USING PigStorage('\t') as (ls2_word:chararray , ls2_score: float);

J1 = JOIN SIMWORDS BY word1, LIN1 BY w1_word;
J2 = JOIN J1 BY (word2,w1_feature), LIN2 BY (w2_word,w2_feature);
G1 = GROUP J2 BY (word1,word2);
G2 = FOREACH G1 GENERATE FLATTEN(group) as (word1,word2), SUM(J2.w1_score)+SUM(J2.w2_score) as w12_score;


J3 = JOIN G2 BY word1, LINSUM1 BY ls1_word;
J4 = JOIN J3 BY word2, LINSUM2 BY ls2_word;


G2 = FOREACH J4 GENERATE word1,word2, w12_score/(ls1_score+ls2_score);



STORE G2 INTO '$out' USING PigStorage('\t');

