-- setting the number of parallel mapred tasks

SET default_parallel 100;
SET mapred.job.map.memory.mb 2048;
SET mapred.job.reduce.memory.mb 2048;

SET mapred.compress.map.output true;
SET mapred.output.compression org.apache.hadoop.io.compress.GzipCodec;

%declare TTEST 'news120M__ContextDP_POS_Clean_Lemma__TTEST3';
%declare SIMCOUNT 'news120M__ContextDP_POS_NP__FreqSigLMI_s_0_t_0__PruneGraph_p_1000__AggrPerFt__SimCounts1WithFeatures__SimSortlimit_200';
%declare WORDS 'weeds_words';
%declare WORDFEATURE 'news120M__ContextDP_POS_Clean_Lemma__WordFeatureCount2';


W1 = LOAD 'news120M__ContextDP_POS_Clean_Lemma__LIN98A' USING PigStorage('\t')  as (w1_word: chararray, w1_feature: chararray, w1_score: float);
J1 = GROUP W1 BY w1_word;
J2 = FOREACH J1 GENERATE group as w1_word, SUM(W1.w1_score);
STORE J2 INTO 'news120M__SimLin98A_SumWord' USING PigStorage('\t');

