-- setting the number of parallel mapred tasks
SET default_parallel 100;
SET mapred.job.map.memory.mb 2048
SET mapred.job.reduce.memory.mb 2048

SET mapred.compress.map.output true
SET mapred.output.compression org.apache.hadoop.io.compress.GzipCodec;

SET pig.tmpfilecompression true
SET pig.tmpfilecompression.codec gz

--%declare FILE_FC 'news100k__ContextDP_POS_Clean_Lemma__FeatureCount';
--%declare FILE_WFRC 'news100k__ContextDP_POS_Clean_Lemma__WordFeatureRelationCount';
--%declare FILE_WC 'news100k__ContextDP_POS_Clean_Lemma__WordCount'
--%declare FILE_RC 'news100k__ContextDP_POS_Clean_Lemma__RelationCount'
--%declare FILE_WRC 'news100k__ContextDP_POS_Clean_Lemma__WordRelationCount'
--%declare FILE_OUT 'news100k__ContextDP_POS_Clean_Lemma__LIN98A2'
--%declare FILE_SUM_OUT 'news100k__ContextDP_POS_Clean_Lemma__LIN98A2_SUM'



FC  = LOAD '$fc' USING PigStorage('\t')  as (fc_feature: chararray, fc_count: float);
WFRC = LOAD '$wfrc' USING PigStorage('\t')  as (wfrc_word: chararray, wfrc_feature: chararray,wfrc_relation:chararray, wfrc_count: float);
WC  = LOAD '$wc' USING PigStorage('\t')  as (wc_word: chararray, wc_count: float);
RC  = LOAD '$rc' USING PigStorage('\t')  as (rc_relation: chararray, rc_count: float);
WRC = LOAD '$wrc' USING PigStorage('\t') as (wrc_word:chararray, wrc_relation : chararray, wrc_count:float);


--T0 = JOIN NOUNS BY noun , WFRC BY wfrc_word;
T1 = JOIN WFRC BY wfrc_feature, FC BY fc_feature;
T2 = JOIN T1 BY wfrc_word , WC BY wc_word;
T4 = JOIN T2 BY wfrc_relation , RC BY rc_relation;
T5 = JOIN T4 BY (wfrc_word,wfrc_relation), WRC BY (wrc_word,wrc_relation);
--J1 = GROUP T4 BY wfrc_word,wfrc_featurep
E = FOREACH T5 GENERATE wfrc_word, wfrc_feature, (LOG((wfrc_count*rc_count)/(fc_count*wrc_count))/LOG(2) );
STORE E INTO '$out' USING PigStorage('\t');


LIN = LOAD '$out' USING PigStorage('\t') as (lin_word: chararray, lin_feature:chararray, lin_score:float);
G1 = GROUP LIN BY lin_word;
OUT = FOREACH G1 GENERATE group, SUM(LIN.lin_score);
STORE OUT INTO '$sum_out' USING PigStorage('\t');
