-- setting the number of parallel mapred tasks
SET default_parallel 100;
SET mapred.job.map.memory.mb 2048
SET mapred.job.reduce.memory.mb 2048

SET mapred.compress.map.output true
SET mapred.output.compression org.apache.hadoop.io.compress.GzipCodec;
--%declare fc 'news100k__ContextDP_POS_Clean_Lemma__FeatureCount'
--%declare wfc 'news100k__ContextDP_POS_Clean_Lemma__WordFeatureCount'
--%declare wc 'news100k__ContextDP_POS_Clean_Lemma__WordCount'
--%declare out 'news100k__ContextDP_POS_Clean_Lemma__TTEST'

FC  = LOAD '$fc' USING PigStorage('\t')  as (fcfeature: chararray, fc_count: float);
WFC = LOAD '$wfc' USING PigStorage('\t')  as (wfcword: chararray, wfcfeature: chararray, wfc_count: float);
WC  = LOAD '$wc' USING PigStorage('\t')  as (wcword: chararray, wc_count: float);

KK = GROUP WFC all;
Z = foreach KK generate SUM(WFC.wfc_count) as total;

T1 = JOIN WFC BY wfcfeature, FC BY fcfeature;
T2 = JOIN T1 BY wfcword , WC BY wcword;

E = FOREACH T2 GENERATE wfcword, wfcfeature, ((wfc_count/Z.total-fc_count/Z.total*wc_count/Z.total)/(SQRT(fc_count/Z.total*wc_count/Z.total)) );
STORE E INTO '$out' USING PigStorage('\t');

